config/routes.rb
Rails.application.routes.draw do
  	resources :departamentos
	resources :produtos, only: [:new, :create, :destroy, :edit, :update]
	get "/produtos/busca" => "produtos#busca", as: :busca_produto
	root "produtos#index"
end

app/models/departamento.rb
class Departamento < ActiveRecord::Base
end

app/models/produto.rb
class Produto < ActiveRecord::Base

	belongs_to :departamento    

	validates :quantidade, presence: true
	validates :nome, length: {minimum: 5}
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
end

app/controllers/departamentos_controller.rb
class DepartamentosController < ApplicationController
  before_action :set_departamento, only: [:show, :edit, :update, :destroy]

  # GET /departamentos
  def index
    @departamentos = Departamento.all
  end

  # GET /departamentos/1
  def show
  end

  # GET /departamentos/new
  def new
    @departamento = Departamento.new
  end

  # GET /departamentos/1/edit
  def edit
  end

  # POST /departamentos
  def create
    @departamento = Departamento.new(departamento_params)

    if @departamento.save
      redirect_to @departamento, notice: 'Departamento was successfully created.'
    else
      render :new
    end
  end

  # PATCH/PUT /departamentos/1
  def update
    if @departamento.update(departamento_params)
      redirect_to @departamento, notice: 'Departamento was successfully updated.'
    else
      render :edit
    end
  end

  # DELETE /departamentos/1
  def destroy
    @departamento.destroy
    redirect_to departamentos_url, notice: 'Departamento was successfully destroyed.'
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_departamento
      @departamento = Departamento.find(params[:id])
    end

    # Only allow a trusted parameter "white list" through.
    def departamento_params
      params.require(:departamento).permit(:nome)
    end
end

app/controllers/produtos_controller.rb
class ProdutosController < ApplicationController

	before_action :set_produto, only: [:edit, :update, :destroy]

	def index
		@produtos_por_nome = Produto.order(:nome).limit 5
		@produtos_por_preco = Produto.order(:preco).limit 2
	end

	def busca
		@nome_a_buscar = params[:nome]
		@produtos = Produto.where "nome like ?", "%#{@nome_a_buscar}%"
	end

	def new
		@produto = Produto.new
		renderiza :new
	end

	def edit
		renderiza :edit
	end

	def update
		if @produto.update produto_params
			flash[:notice] = "Produto atualizado com sucesso"
			redirect_to root_url
		else
			renderiza :edit
		end
	end	

	def create
		@produto = Produto.new produto_params
		if @produto.save
			flash[:notice] = "Produto salvo com sucesso"
			redirect_to root_url
		else
			renderiza :new
		end
	end	

	def destroy
		@produto.destroy
		redirect_to root_url
	end

	private

	def renderiza(view)
		@departamentos = Departamento.all
		render view
	end	

	def set_produto
		id = params[:id]
		@produto = Produto.find(id)
	end

	def produto_params
		params.require(:produto)
			.permit(:nome, :descricao, :quantidade, :preco, :departamento_id)
	end	
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/departamentos_helper.rb
module DepartamentosHelper
end

app/helpers/produtos_helper.rb
module ProdutosHelper
end

app/views/departamentos/_form.html.erb
<%= form_for(@departamento) do |f| %>
  <% if @departamento.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@departamento.errors.count, "error") %> prohibited this departamento from being saved:</h2>

      <ul>
      <% @departamento.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :nome %><br>
    <%= f.text_field :nome %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/departamentos/edit.html.erb
<h1>Editing Departamento</h1>

<%= render 'form' %>

<%= link_to 'Show', @departamento %> |
<%= link_to 'Back', departamentos_path %>

app/views/departamentos/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Departamentos</h1>

<table>
  <thead>
    <tr>
      <th>Nome</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @departamentos.each do |departamento| %>
      <tr>
        <td><%= departamento.nome %></td>
        <td><%= link_to 'Show', departamento %></td>
        <td><%= link_to 'Edit', edit_departamento_path(departamento) %></td>
        <td><%= link_to 'Destroy', departamento, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Departamento', new_departamento_path %>

app/views/departamentos/new.html.erb
<h1>New Departamento</h1>

<%= render 'form' %>

<%= link_to 'Back', departamentos_path %>

app/views/departamentos/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Nome:</strong>
  <%= @departamento.nome %>
</p>

<%= link_to 'Edit', edit_departamento_path(@departamento) %> |
<%= link_to 'Back', departamentos_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Loja de camisetas</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>

	<%= nav_bar brand: "Kunstee", brand_link: root_url do %>
		<%= form_tag busca_produto_path, 
									method: :get, 
									class: "navbar-form navbar-right" do %>
			<div class="form-group">
				<%= text_field_tag :nome, @nome_a_buscar, class: "form-control" %>
				<%= button_to "Buscar", nil, class: "btn btn-primary" %>
			</div>	
		<% end %>
	<% end %>

	<div class="container">	
		<%= yield %>
	</div>
</body>
</html>

app/views/produtos/_form.html.erb
<% @produto.errors.full_messages.each do |message| %>
	<div class="alert alert-danger">
		<%= message %>
	</div>
<% end %>

<%= form_for @produto do |f| %>
	
	<div class="form-group">
		<%= f.label :nome %>
		<%= f.text_field :nome, class: "form-control" %>
	</div>	

	<div class="form-group">
		<%= f.label :descricao %>
		<%= f.text_area :descricao, rows: 4, class: "form-control" %>
	</div>

	<div class="form-group">
		<%= f.label :departamento %>
		<%= f.collection_select :departamento_id, @departamentos, :id, :nome, 
															{}, class: "form-control"  %>
	</div>

	<div class="form-inline">
		<div class="form-group">
			<%= f.label :quantidade %>
			<%= f.number_field :quantidade, step: 1, class: "form-control" %>
		</div>

		<div class="form-group">
			<%= f.label :preco %>	
			<%= f.number_field :preco, step: 0.01, class: "form-control" %>
		</div>

		<%= f.submit texto_da_acao, class: "btn btn-primary" %>
	</div>	
<% end %>

app/views/produtos/_produto.html.erb
<tr>
	<td><%= produto.nome %></td>
	<td><%= produto.descricao %></td>
	<td><%= produto.preco %></td>
	<td>
		<%= button_to "Remover", produto, 
								method: :delete, 
								class: "btn btn-danger",
								data: { confirm: "Tem certeza que deseja remover #{produto.nome}?" } %>
	</td>
	<td>
		<%= link_to "Alterar", edit_produto_path(produto), class: "btn btn-default" %>
	</td>
</tr>

app/views/produtos/busca.html.erb
<table class="table table-bordered">
	<thead>
		<tr>
			<th>Nome</th>
			<th>Descrição</th>
			<th>Preço</th>
		</tr>
	</thead>
	<tbody>
		<%= render partial: "produtos" %>
	</tbody>
</table>

app/views/produtos/edit.html.erb
<%= render partial: 'form', locals: { texto_da_acao: 'Atualizar o produto' } %>

app/views/produtos/index.html.erb
<% if flash[:notice] %>
	<div class="alert alert-success">
		<%= flash[:notice] %>
	</div>
<% end %>

<table class="table table-bordered">
	<thead>
		<tr>
			<th>Nome</th>
			<th>Descrição</th>
			<th>Preço</th>
		</tr>
	</thead>
	<tbody>
		<%= render @produtos_por_nome %>
	</tbody>
</table>

<table class="table table-bordered">
	<thead>
		<tr>
			<th>Nome</th>
			<th>Descrição</th>
			<th>Preço</th>
		</tr>
	</thead>
	<tbody>
		<%= render @produtos_por_preco %>
	</tbody>
</table>

<%= link_to "Criar novo produto", new_produto_path %>

app/views/produtos/new.html.erb
<%= render partial: 'form', locals: { texto_da_acao: 'Criar o produto' } %>